from os import *
from os import _exit
from signal import *
from sys import *
import logging

_logger = logging.getLogger("api.daemon")

def daemon():

    stdout.flush()
    stderr.flush()

    (readfd, writefd) = pipe()

    try:
        pid = fork()
    except OSError, e:
        return ((e.errno, e.strerror))

    if pid == 0:
        close(readfd)
        #child

        #become a session leader
        setsid()
        signal(SIGHUP, SIG_IGN)

        try:
            pid = fork()
        except OSError, e:
            return ((e.errno, e.strerror))

        if pid <> 0:
            _exit(0)
    else:
        close(writefd)

        while True:
            data = read(readfd, 1)
            if len(data) == 0:
                break

        _exit(0)

    for fd in range(0, 3):
        try:
            close(fd)
        except OSError, e:
            pass

    open("/dev/null", O_RDONLY) #stdin
    open("/dev/null", O_WRONLY) #stdout
    open("/dev/null", O_WRONLY) #stderr

    close(writefd) #parent may terminate

    return 0

if __name__ == "__main__":
    x = daemon()
    while True:
        pass
